<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="folder-filter-panel w-100 bg-light">
  <div class="ms-3 shadow-sm d-flex flex-column h-100 bg-white p-4">
    <form class="ls-form bg-white w-100">
      <div class="form-group">
        <label
          [innerText]="commonMessages.TYPE"
          for="typeSelector">
        </label>
        <app-type-selector
          (typeChange)="typeSelectionChanged($event)"
          [(type)]="type"
          [retrieveTypesFunction]="retrieveTypesFn"
          class="desk-selector"
          id="typeSelector">
        </app-type-selector>
      </div>

      <div class="form-group">
        <label
          [innerText]="commonMessages.SUBTYPE"
          for="subtypeSelector">
        </label>
        <app-subtype-selector
          (subtypeChange)="subtypeSelectionChanged($event)"
          [(subtype)]="subtype"
          [tenantId]="tenantId"
          [type]="type"
          [retrieveSubtypesFunction]="retrieveSubtypesFn"
          class="desk-selector"
          id="subtypeSelector">
        </app-subtype-selector>
      </div>

      <div class="form-group">
        <label
          [innerText]="messages.FILTER_FROM_LABEL"
          for="startDate">
        </label>
        <input
          [(ngModel)]="createdAt"
          (change)="createdAtDateChanged()"
          class="form-control"
          id="startDate"
          name="startDate"
          type="date">
      </div>

      <div class="form-group">
        <label
          [innerText]="messages.FILTER_TO_LABEL"
          for="endDate">
        </label>
        <input
          [(ngModel)]="limitDate"
          (change)="limitDateChanged()"
          class="form-control"
          id="endDate"
          name="endDate"
          type="date">
      </div>

      <div class="form-group">
        <label
          [innerText]="commonMessages.TITLE"
          for="title">
        </label>
        <input
          [(ngModel)]="title"
          (change)="checkModifiedFilter()"
          class="form-control"
          id="title"
          name="title"
          type="text">
      </div>

      <div class="form-group">
        <label
          [innerText]="commonMessages.STATE"
          for="folders">
        </label>
        <ng-select
          [(ngModel)]="state"
          (change)="checkModifiedFilter()"
          [clearable]="false"
          [multiple]="false"
          [notFoundText]="commonMessages.NOT_FOUND"
          [searchable]="false"
          id="folders"
          name="folders">

          <ng-option
            *ngFor="let status of filterableStates"
            [innerText]="status | stateName"
            [value]="status">
          </ng-option>
        </ng-select>
      </div>
    </form>
    <div class="bg-white">
      <div class="d-flex flex-column align-items-end">
        <ng-container [ngSwitch]="!loading ? 'default' : 'loading'">
          <ng-container *ngSwitchCase="'default'">
            <button
              class="mb-2"
              ls-button-cancel
              [disabled]="!modifiedFilter"
              [title]="commonMessages.RESET"
              [text]="commonMessages.RESET"
              [icon]="commonIcons.RE_INIT_ICON"
              (click)="resetFilter()">
            </button>
            <button
              ls-button-cancel
              class="mb-2 mw-100 overflow-hidden text-overflow-ellipsis"
              *ngIf="filter?.id"
              [title]="messages.deleteFilter(filter.filterName)"
              [text]="messages.deleteFilter(filter.filterName)"
              [icon]="commonIcons.DELETE_ICON"
              [style]="style.DANGER"

              (click)="deleteCurrentFilter()">
            </button>
            <button
              class="mb-2"
              ls-button-cancel
              *ngIf="filter?.id && modifiedFilter"
              [title]="messages.saveFilter(filter.filterName)"
              [text]="messages.saveFilter(filter.filterName)"
              [icon]="commonIcons.SAVE_ICON"
              [style]="style.NEUTRAL"
              (click)="saveOrUpdateFilter()">
            </button>
            <button
              ls-button-cancel
              [title]="messages.NEW_FILTER"
              [text]="messages.NEW_FILTER"
              [icon]="commonIcons.SAVE_ICON"
              [style]="style.NEUTRAL"
              (click)="saveOrUpdateFilter(true)">
            </button>
          </ng-container>

          <ng-container *ngSwitchCase="'loading'">
            <fa-icon [icon]="commonIcons.SPINNER_ICON" [spin]=true></fa-icon>
          </ng-container>
        </ng-container>
      </div>
    </div>

    <div class="d-flex justify-content-end mt-2">
      <button
        ls-button
        [icon]="icons.FILTER_ICON"
        [text]="messages.FILTER_BUTTON_LABEL"
        (click)="applyFilter(getFilter(), false, false)">
      </button>
    </div>
  </div>
</div>
